unit MtT ; (* Multy Thread support *)

{$L mp_code.obj}
{$L sys.obj}

interface

{$F+}

type
  ProcDescriptor =
    record
      NextProc  : WORD ;
      FarCall   : WORD ;
      FCall_IP  : WORD ;
      FCall_CS  : WORD ;
      Proc_SP   : WORD ;
      Proc_SS   : WORD ;
      ProcPrio	: WORD
    end {record} ;

  PROCESS        =
    ^ProcDescriptor    ;

  Priority  =
   ( irq0, irq1, irq2, irq3, irq4, irq5, irq6, irq7, (* bits for $021 mask *)
     irq8, irq9, irqA, irqB, irqC, irqD, irqE, irqF  (* bits for $0A1 mask *)
   ) ;

  IntMask   =
    set of
      Priority ;


var
  CurrentProcess : pointer ;

procedure MainProc; far ;
procedure initprocess ; far ;
procedure NEWPROCESS( P : pointer ; A : pointer ; S : word ; var P1 : PROCESS ) ; far ;
procedure TRANSFER   ( var p1 , p2 : PROCESS ) ; far ;
procedure IOTRANSFER ( var p1 , p2 : PROCESS ; int : word ) ; far ;
function  GetCurrentProcess:PROCESS ; far ;
function  CurrentPriority: word ; far ;
procedure NewPriority( pr : word) ; far ;

implementation

procedure MainProc; external ;
procedure initprocess ; external ;
procedure NEWPROCESS( P : pointer ; A : pointer ; S : word ; var P1 : PROCESS ) ; external ;
procedure TRANSFER  ( var p1 , p2 : PROCESS ) ; external ;
procedure IOTRANSFER( var p1 , p2 : PROCESS ; int : word ) ; external ;
function  GetCurrentProcess:PROCESS ; external ;
function  CurrentPriority: word ; external ;
procedure NewPriority( pr : word ) ; external ;

end .
